package com.style24.persistence;

import java.io.Serializable;

import lombok.Data;

/**
 * Paging
 * @author gagamel
 * @since 2020. 2. 14
 */
@SuppressWarnings("serial")
@Data
public class TsfPageRequest implements Serializable {

	private final int pageNo;   // 페이지번호
	private final int pageSize; // 조회할 row수
	private final int pageUnit; // 그룹핑 페이지 단위
	private int totalCount = 0; // 전체 row 건수

	public TsfPageRequest(int pageNo, int pageSize) {
		this(pageNo, pageSize, 10);
	}

	public TsfPageRequest(int pageNo, int pageSize, int pageUnit) {
		if (pageNo < 0) {
			throw new IllegalArgumentException("Current page index must not be less than zero!");
		}

		if (pageSize < 1) {
			throw new IllegalArgumentException("Page size must not be less than one!");
		}

		if (pageUnit < 1) {
			throw new IllegalArgumentException("Page unit must not be less than one!");
		}

		this.pageNo = pageNo;
		this.pageSize = pageSize;
		this.pageUnit = pageUnit;
	}

	public int getPageNo() {
		return pageNo + 1;
	}

	public int getOffset() {
		return pageNo * pageSize;
	}

	public int getStartRow() {
		return pageNo * pageSize + 1;
	}

	public int getEndRow() {
		return getOffset() + pageSize;
	}

	public int getPageGroup() {
		return pageNo / pageUnit + 1;
	}

	public void setTotalCount(int totalCount) {
		this.totalCount = totalCount;
	}

	public int getTotalPage() {
		int totalPage = totalCount / pageSize;
		if (totalCount % pageSize > 0) totalPage++;
		return totalPage;
	}

	public String getGeneratedPagination() {
		int firstCount = (getPageGroup() - 1) * pageUnit + 1;
		int loopCount = firstCount + pageUnit;
		if (loopCount > getTotalPage()) loopCount = getTotalPage() + 1;

		StringBuffer pageTag = new StringBuffer();

		if (getPageNo() == 1) {
			pageTag.append("<a href=\"#\" class=\"icon first\" alt=\"처음 페이지\">처음 페이지</a>\n");
		} else {
			pageTag.append("<a href=\"#pageNo=1\" class=\"icon first\" alt=\"처음 페이지\">처음 페이지</a>\n");
		}

		if (getPageGroup() == 1) {
			pageTag.append("<a href=\"#\" class=\"icon prev\" alt=\"이전페이지\">이전 페이지</a>\n");
		} else {
			pageTag.append("<a href=\"#pageNo=").append((getPageGroup() - 1) * pageUnit).append("\" class=\"icon prev\" alt=\"이전페이지\">이전 페이지</a>\n");
		}

		for (int i = firstCount; i < loopCount; i++) {
			if (getPageNo() == i) {
				pageTag.append("<a class=\"num on\" href=\"#\">").append(i).append("</a>\n");
			} else {
				pageTag.append("<a class=\"num\" href=\"#pageNo=").append(i).append("\">").append(i).append("</a>\n");
			}
		}

		if (loopCount <= (getTotalPage() + 1)) {
			if (getPageNo() == getTotalPage() || getTotalPage()<=(getPageGroup() * pageUnit)) {
				//				pageTag.append("<a href=\"#\" class=\"icon next\" alt=\"다음 페이지\">다음 페이지</a>\n");
				//				pageTag.append("<a href=\"#\" class=\"icon last\" alt=\"마지막 페이지\">마지막 페이지</a>\n");
				pageTag.append("<a href=\"#pageNo=").append(getPageNo()).append("\" class=\"icon next\" alt=\"다음 페이지\">다음 페이지</a>\n");
				pageTag.append("<a href=\"#pageNo=").append(getPageNo()).append("\" class=\"icon last\" alt=\"마지막 페이지\">마지막 페이지</a>\n");
			} else {
				pageTag.append("<a href=\"#pageNo=").append(getPageGroup() * pageUnit + 1).append("\" class=\"icon next\" alt=\"다음 페이지\">다음 페이지</a>\n");
				pageTag.append("<a href=\"#pageNo=").append(getTotalPage()).append("\" class=\"icon last\" alt=\"마지막 페이지\">마지막 페이지</a>\n");
			}
		}

		return pageTag.toString();
	}

	@Override
	public String toString() {
		return String.format("Page request [pageNo: %d, pageSize %d, pageUnit %d]", getPageNo(), pageSize, pageUnit);
	}

}
